
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import javafx.scene.control
import jisa.control
import jisa.gui
import typing



class DoubleField(jisa.gui.Field[float]):
    def editValues(self, *string: str) -> None: ...
    def get(self) -> float: ...
    def getText(self) -> str: ...
    def isDisabled(self) -> bool: ...
    def isVisible(self) -> bool: ...
    def set(self, double: float) -> None: ...
    def setDisabled(self, boolean: bool) -> None: ...
    def setLeading(self, int: int) -> None: ...
    def setOnChange(self, sRunnable: typing.Union[jisa.control.SRunnable, typing.Callable]) -> None: ...
    def setText(self, string: str) -> None: ...
    def setVisible(self, boolean: bool) -> None: ...

class StringField(jisa.gui.Field[str]):
    def __init__(self, label: javafx.scene.control.Label, textField: javafx.scene.control.TextField): ...
    def editValues(self, *string: str) -> None: ...
    def get(self) -> str: ...
    def getText(self) -> str: ...
    def isDisabled(self) -> bool: ...
    def isVisible(self) -> bool: ...
    def remove(self) -> None: ...
    def set(self, string: str) -> None: ...
    def setDisabled(self, boolean: bool) -> None: ...
    def setOnChange(self, sRunnable: typing.Union[jisa.control.SRunnable, typing.Callable]) -> None: ...
    def setText(self, string: str) -> None: ...
    def setVisible(self, boolean: bool) -> None: ...

class TimeField(jisa.gui.Field[int]):
    def editValues(self, *string: str) -> None: ...
    def get(self) -> int: ...
    def getText(self) -> str: ...
    def isDisabled(self) -> bool: ...
    def isVisible(self) -> bool: ...
    def set(self, integer: int) -> None: ...
    def setDisabled(self, boolean: bool) -> None: ...
    def setOnChange(self, sRunnable: typing.Union[jisa.control.SRunnable, typing.Callable]) -> None: ...
    def setText(self, string: str) -> None: ...
    def setVisible(self, boolean: bool) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("jisa.gui.fields")``.

    DoubleField: typing.Type[DoubleField]
    StringField: typing.Type[StringField]
    TimeField: typing.Type[TimeField]
